<?xml version='1.0' encoding='utf-8'?>
<config><compat-change description="Guards whether or not measurements of MBA to be performed. When this change is enabled, measurements of MBAs are performed. But when it is disabled, only measurements of APEX and modules are done." id="245692487" name="LOG_MBA_INFO" /><compat-change description="For Android U and earlier versions, apps can continue to use the READ_LOGS permission, but for all subsequent versions, the READ_DROPBOX_DATA permission must be used." enableAfterTargetSdk="34" id="296060945" name="ENFORCE_READ_DROPBOX_DATA" /><compat-change description="Support backward compatibility for {@link android.telephony.TelephonyDisplayInfo}." enableSinceTargetSdk="31" id="181658987" name="DISPLAY_INFO_NR_ADVANCED_SUPPORTED" /><compat-change description="To check the SDK version for {@link android.telephony.TelephonyCallback.DisplayInfoListener} should remove {@link android.Manifest.permission#READ_PHONE_STATE} since Android 12." enableSinceTargetSdk="31" id="183164979" name="REQUIRE_READ_PHONE_STATE_PERMISSION_FOR_DISPLAY_INFO" /><compat-change description="To check the SDK version for {@link android.telephony.TelephonyCallback.ActiveDataSubscriptionIdListener} should add {@link android.Manifest.permission#READ_PHONE_STATE} since Android 12." enableSinceTargetSdk="31" id="182478738" name="REQUIRE_READ_PHONE_STATE_PERMISSION_FOR_ACTIVE_DATA_SUB_ID" /><compat-change description="To check the SDK version for {@link android.telephony.TelephonyCallback.CellInfoListener} should add {@link android.Manifest.permission#READ_PHONE_STATE} since Android 12." enableSinceTargetSdk="31" id="184323934" name="REQUIRE_READ_PHONE_STATE_PERMISSION_FOR_CELL_INFO" /><compat-change description="Apps targeting Android U and above need to declare the package visibility needs in the manifest to access the AccountManager APIs." enableAfterTargetSdk="33" id="154726397" name="ENFORCE_PACKAGE_VISIBILITY_FILTERING" /><compat-change description="Disables foreground service background starts from BOOT_COMPLETED broadcasts for all types except: &lt;ul&gt;     &lt;li&gt;{@link android.content.pm.ServiceInfo#FOREGROUND_SERVICE_TYPE_LOCATION}&lt;/li&gt;     &lt;li&gt;{@link android.content.pm.ServiceInfo#FOREGROUND_SERVICE_TYPE_CONNECTED_DEVICE}&lt;/li&gt;     &lt;li&gt;{@link android.content.pm.ServiceInfo#FOREGROUND_SERVICE_TYPE_REMOTE_MESSAGING}&lt;/li&gt;     &lt;li&gt;{@link android.content.pm.ServiceInfo#FOREGROUND_SERVICE_TYPE_HEALTH}&lt;/li&gt;     &lt;li&gt;{@link android.content.pm.ServiceInfo#FOREGROUND_SERVICE_TYPE_SYSTEM_EXEMPTED}&lt;/li&gt;     &lt;li&gt;{@link android.content.pm.ServiceInfo#FOREGROUND_SERVICE_TYPE_SPECIAL_USE}&lt;/li&gt; &lt;/ul&gt;" enableSinceTargetSdk="35" id="296558535" name="FGS_BOOT_COMPLETED_RESTRICTIONS" overridable="true" /><compat-change description="Disables foreground service background starts in System Alert Window for all types unless it already has a System Overlay Window." enableSinceTargetSdk="35" id="319471980" name="FGS_SAW_RESTRICTIONS" overridable="true" /><compat-change description="Foreground services of certain types will now have a time limit. If the foreground service of the offending type is not stopped within the allocated time limit, it will receive a callback via {@link Service#onTimeout(int, int)} and it must then be stopped within a few seconds. If an app fails to do so, it will be declared an ANR. @see Service#onTimeout(int, int) onTimeout callback for additional details" enableSinceTargetSdk="35" id="317799821" name="FGS_INTRODUCE_TIME_LIMITS" /><compat-change description="The BG-launch FGS restriction feature is going to be allowed only for apps targetSdkVersion is higher than R." enableSinceTargetSdk="31" id="170668199" name="FGS_BG_START_RESTRICTION_CHANGE_ID" overridable="true" /><compat-change description="If a service can not become foreground service due to BG-FGS-launch restriction or other reasons, throws an IllegalStateException." enableSinceTargetSdk="31" id="174041399" name="FGS_START_EXCEPTION_CHANGE_ID" /><compat-change description="If enabled, the FGS type check against the manifest FSG type will be enabled for instant apps too. Before U, this check was only done for non-instant apps." enableAfterTargetSdk="33" id="261055255" name="FGS_TYPE_CHECK_FOR_INSTANT_APPS" /><compat-change description="Defer LOCKED_BOOT_COMPLETED and BOOT_COMPLETED broadcasts until the first time any process in the UID is started." enableAfterTargetSdk="32" id="203704822" name="DEFER_BOOT_COMPLETED_BROADCAST_CHANGE_ID" overridable="true" /><compat-change description="It is now required for apps to explicitly set either {@link android.content.Context#RECEIVER_EXPORTED} or {@link android.content.Context#RECEIVER_NOT_EXPORTED} when registering a receiver for an unprotected broadcast in code." enableSinceTargetSdk="34" id="161145287" name="DYNAMIC_RECEIVER_EXPLICIT_EXPORT_REQUIRED" /><compat-change description="This flag has to be enabled for the &quot;android&quot; package to use component aliases." disabled="true" id="196254758" name="USE_EXPERIMENTAL_COMPONENT_ALIAS" /><compat-change description="Flag {@link android.content.Context#BIND_INCLUDE_CAPABILITIES} is used to pass while-in-use capabilities from client process to bound service. In targetSdkVersion R and above, if client is a TOP activity, when this flag is present, bound service gets all while-in-use capabilities; when this flag is not present, bound service gets no while-in-use capability from client." enableAfterTargetSdk="29" id="136274596" name="PROCESS_CAPABILITY_CHANGE_ID" /><compat-change description="In targetSdkVersion R and above, foreground service has camera and microphone while-in-use capability only when the {@link android.R.attr#foregroundServiceType} is configured as {@link android.content.pm.ServiceInfo#FOREGROUND_SERVICE_TYPE_CAMERA} and {@link android.content.pm.ServiceInfo#FOREGROUND_SERVICE_TYPE_MICROPHONE} respectively in the manifest file. In targetSdkVersion below R, foreground service automatically have camera and microphone capabilities." enableAfterTargetSdk="29" id="136219221" name="CAMERA_MICROPHONE_CAPABILITY_CHANGE_ID" /><compat-change description="For apps targeting S+, this determines whether to use a shorter timeout before elevating the standby bucket to ACTIVE when apps start a foreground service." enableSinceTargetSdk="31" id="183972877" name="USE_SHORT_FGS_USAGE_INTERACTION_TIME" /><compat-change description="If enabled BAL are prevented by default in applications targeting U and later." enableAfterTargetSdk="33" id="244637991" name="DEFAULT_RESCIND_BAL_PRIVILEGES_FROM_PENDING_INTENT_SENDER" overridable="true" /><compat-change description="Apps have no access to the private data directories of any other app, even if the other app has made them world-readable." enableAfterTargetSdk="29" id="143937733" name="APP_DATA_DIRECTORY_ISOLATION" /><compat-change description="Compat ID to enable the new FGS start logic, for permission calculation used for per-FGS-type eligibility calculation. (See also android.app.ForegroundServiceTypePolicy)" enableAfterTargetSdk="34" id="311208629" name="USE_NEW_WIU_LOGIC_FOR_START" /><compat-change description="Compat ID to enable the new FGS start logic, for capability calculation." enableAfterTargetSdk="34" id="313677553" name="USE_NEW_WIU_LOGIC_FOR_CAPABILITIES" /><compat-change description="Compat ID to enable the new FGS start logic, for deciding whether to allow FGS start from the background." enableAfterTargetSdk="34" id="311208749" name="USE_NEW_BFSL_LOGIC" /><compat-change description="Indicates that default communication device is chosen by routing rules in audio policy manager and not forced by AudioDeviceBroker." enableSinceTargetSdk="32" id="243827847" name="USE_SET_COMMUNICATION_DEVICE" /><compat-change description="When  this change is enabled, {@code adb backup}  is automatically turned on for apps running as debuggable ({@code android:debuggable} set to {@code true}) and unavailable to any other apps." enableSinceTargetSdk="31" id="171032338" name="RESTRICT_ADB_BACKUP" /><compat-change description="When  this change is enabled, {@code android:allowBackup}  is ignored for apps during D2D (device-to-device) migrations." enableSinceTargetSdk="31" id="183147249" name="IGNORE_ALLOW_BACKUP_IN_D2D" overridable="true" /><compat-change description="With RADIO_U_VERSION_REQUIRED enabled, 44-bit DAB identifier {@code IdentifierType#DAB_SID_EXT} from broadcast radio HAL can be passed as {@code ProgramSelector#IDENTIFIER_TYPE_DAB_DMB_SID_EXT} to {@code RadioTuner}." enableSinceTargetSdk="34" id="261770108" name="RADIO_U_VERSION_REQUIRED" /><compat-change description="With RADIO_V_VERSION_REQUIRED enabled, identifier types, config flags and metadata added in V for HD radio can be passed to {@code RadioTuner} by {@code android.hardware.radio.ITunerCallback}" enableSinceTargetSdk="35" id="302589903" name="RADIO_V_VERSION_REQUIRED" /><compat-change description="When enabled this change id forces the packages it is applied to override the default camera rotate &amp; crop behavior and always return CaptureRequest.SCALER_ROTATE_AND_CROP_NONE . The default behavior along with all possible override combinations is discussed in the table below." disabled="true" id="189229956" name="OVERRIDE_CAMERA_ROTATE_AND_CROP_DEFAULTS" overridable="true" /><compat-change description="When enabled this change id forces the packages it is applied to ignore the current value of 'android:resizeableActivity' as well as target SDK equal to or below M and consider the activity as non-resizeable. In this case, the value of camera rotate &amp; crop will only depend on the needed compensation considering the current display rotation." disabled="true" id="191513214" name="OVERRIDE_CAMERA_RESIZABLE_AND_SDK_CHECK" overridable="true" /><compat-change description="If required, allow the secure activity to display on remote device since {@link android.os.Build.VERSION_CODES#TIRAMISU}." enableSinceTargetSdk="33" id="201712607" name="ALLOW_SECURE_ACTIVITY_DISPLAY_ON_REMOTE_DEVICE" /><compat-change description="Do not show a toast on the virtual display when a secure surface is shown after {@link android.os.Build.VERSION_CODES#VANILLA_ICE_CREAM}. VDM clients should use {@link VirtualDeviceManager.ActivityListener#onSecureWindowShown} instead to provide a custom notification if desired." enableAfterTargetSdk="35" id="311101667" name="DO_NOT_SHOW_TOAST_WHEN_SECURE_SURFACE_SHOWN" /><compat-change description="A change ID to be used only in the CTS test for this SystemApi" enableSinceTargetSdk="31" id="149391281" name="CTS_SYSTEM_API_CHANGEID" /><compat-change description="An overridable change ID to be used only in the CTS test for this SystemApi" disabled="true" id="174043039" name="CTS_SYSTEM_API_OVERRIDABLE_CHANGEID" overridable="true" /><compat-change description="Enables checking for account access for the calling uid on all sync-related APIs." enableAfterTargetSdk="32" id="201794303" name="ACCOUNT_ACCESS_CHECK_CHANGE_ID" /><compat-change description="Enables checking for authority access for the calling uid on all sync-related APIs." enableAfterTargetSdk="33" id="207133734" name="AUTHORITY_ACCESS_CHECK_CHANGE_ID" /><compat-change description="For admin apps targeting R+, throw when the app sets password requirement that is not taken into account at given quality. For example when quality is set to {@link android.app.admin.DevicePolicyManager#PASSWORD_QUALITY_UNSPECIFIED}, it doesn't make sense to require certain password length. If the intent is to require a password of certain length having at least NUMERIC quality, the admin should first call {@link android.app.admin.DevicePolicyManager#setPasswordQuality} and only then call {@link android.app.admin.DevicePolicyManager#setPasswordMinimumLength}. &lt;p&gt;Conversely when an admin app targeting R+ lowers password quality, those requirements that stop making sense are reset to default values." enableAfterTargetSdk="29" id="123562444" name="ADMIN_APP_PASSWORD_COMPLEXITY" /><compat-change description="Admin apps targeting Android R+ may not use {@link android.app.admin.DevicePolicyManager#setSecureSetting} to change the deprecated {@link android.provider.Settings.Secure#LOCATION_MODE} setting. Instead they should use {@link android.app.admin.DevicePolicyManager#setLocationEnabled}." enableAfterTargetSdk="29" id="117835097" name="USE_SET_LOCATION_ENABLED" /><compat-change description="Forces wipeDataNoLock to attempt removing the user or throw an error as opposed to trying to factory reset the device first and only then falling back to user removal." enableSinceTargetSdk="34" id="242193913" name="EXPLICIT_WIPE_BEHAVIOUR" /><compat-change description="Apps targeting V+ should now expect that attempts to grant sensor permissions without authorisation will result in a security exception." enableSinceTargetSdk="35" id="277035314" name="THROW_SECURITY_EXCEPTION_FOR_SENSOR_PERMISSIONS" /><compat-change description="Allows DPCs to provisioning fully managed headless devices in single-user mode." enableSinceTargetSdk="35" id="289515470" name="PROVISION_SINGLE_USER_MODE" /><compat-change description="Admin apps targeting Android S+ may not use {@link android.app.admin.DevicePolicyManager#setPasswordQuality} to set password quality on the {@code DevicePolicyManager} instance obtained by calling {@link android.app.admin.DevicePolicyManager#getParentProfileInstance}. Instead, they should use {@link android.app.admin.DevicePolicyManager#setRequiredPasswordComplexity} to set coarse-grained password requirements device-wide." enableSinceTargetSdk="31" id="165573442" name="PREVENT_SETTING_PASSWORD_QUALITY_ON_PARENT" /><compat-change description="For Admin Apps targeting U+ If {@link android.security.IKeyChainService#setGrant} is called with an alias with no existing key, throw IllegalArgumentException." enableSinceTargetSdk="34" id="175101461" name="THROW_EXCEPTION_WHEN_KEY_MISSING" /><compat-change description="For apps targeting U+ Enable multiple admins to coexist on the same device." enableSinceTargetSdk="34" id="260560985" name="ENABLE_COEXISTENCE_CHANGE" /><compat-change description="Applications use {@link android.view.Display#getRefreshRate} and {@link android.view.Display.Mode#getRefreshRate} to know what is the display refresh rate. Starting with Android S, the platform might throttle down applications frame rate to a divisor of the refresh rate if it is more preferable (for example if the application called to {@link android.view.Surface#setFrameRate}). Applications will experience {@link android.view.Choreographer#postFrameCallback} callbacks and backpressure at the throttled frame rate. {@link android.view.Display#getRefreshRate} will always return the application frame rate and not the physical display refresh rate to allow applications to do frame pacing correctly. {@link android.view.Display.Mode#getRefreshRate} will return the application frame rate if compiled to a previous release and starting with Android S it will return the physical display refresh rate." enableSinceTargetSdk="31" id="170503758" name="DISPLAY_MODE_RETURNS_PHYSICAL_REFRESH_RATE" /><compat-change description="Require the hosting job to specify a network constraint if the included {@link android.app.job.JobWorkItem} indicates network usage." enableAfterTargetSdk="33" id="241104082" name="REQUIRE_NETWORK_CONSTRAINT_FOR_NETWORK_JOB_WORK_ITEMS" /><compat-change description="Require the app to have the ACCESS_NETWORK_STATE permissions when scheduling a job with a connectivity constraint." enableAfterTargetSdk="33" id="271850009" name="REQUIRE_NETWORK_PERMISSIONS_FOR_CONNECTIVITY_JOBS" /><compat-change description="Throw an exception when biases are set by an unsupported client." enableAfterTargetSdk="34" id="300477393" name="THROW_ON_UNSUPPORTED_BIAS_USAGE" /><compat-change description="Whether to trigger an ANR when apps are slow to respond on pre-UDC APIs and functionality." enableAfterTargetSdk="33" id="258236856" name="ANR_PRE_UDC_APIS_ON_SLOW_RESPONSES" /><compat-change description="For clients targeting S and above, a SecurityException is thrown when they are in the denied authorization state and attempt to send a message to a nanoapp." enableAfterTargetSdk="30" id="181350407" name="CHANGE_ID_AUTH_STATE_DENIED" /><compat-change description="{@link android.media.session.MediaSession#setMediaButtonBroadcastReceiver( android.content.ComponentName)} throws an {@link java.lang.IllegalArgumentException} if the provided {@link android.content.ComponentName} does not resolve to a valid {@link android.content.BroadcastReceiver broadcast receiver} for apps targeting Android U and above. For apps targeting Android T and below, the request will be ignored." enableSinceTargetSdk="34" id="270049379" name="THROW_FOR_INVALID_BROADCAST_RECEIVER" /><compat-change description="{@link android.media.session.MediaSession#setMediaButtonReceiver(android.app.PendingIntent)} throws an {@link java.lang.IllegalArgumentException} if the provided {@link android.app.PendingIntent} targets an {@link android.app.Activity activity} for apps targeting Android V and above. For apps targeting Android U and below, the request will be ignored." enableSinceTargetSdk="35" id="272737196" name="THROW_FOR_ACTIVITY_MEDIA_BUTTON_RECEIVER" /><compat-change description="Determines how to respond to an app re-using a consent token; either failing or allowing the user to re-grant consent. &lt;p&gt;Enabled after version 33 (Android T), so applies to target SDK of 34+ (Android U+)." enableSinceTargetSdk="34" id="266201607" name="MEDIA_PROJECTION_PREVENTS_REUSING_CONSENT" /><compat-change description="Corrects audio attributes for notifications based on characteristics of the notifications." id="331793339" loggingOnly="true" name="RESTRICT_AUDIO_ATTRIBUTES" /><compat-change description="Apps that post custom toasts in the background will have those blocked. Apps can still post toasts created with {@link Toast#makeText(Context, CharSequence, int)} and its variants while in the background." enableAfterTargetSdk="29" id="128611929" name="CHANGE_BACKGROUND_CUSTOM_TOAST_BLOCK" /><compat-change description="Activity starts coming from broadcast receivers or services in response to notification and notification action clicks will be blocked for UX and performance reasons. Instead start the activity directly from the PendingIntent." enableAfterTargetSdk="30" id="167676448" name="NOTIFICATION_TRAMPOLINE_BLOCK" /><compat-change description="Activity starts coming from broadcast receivers or services in response to notification and notification action clicks will be blocked for UX and performance reasons for previously exempt role holders (browser)." enableAfterTargetSdk="32" id="227752274" name="NOTIFICATION_TRAMPOLINE_BLOCK_FOR_EXEMPT_ROLES" /><compat-change description="Whether a notification listeners can understand new, more specific, cancellation reasons." enableAfterTargetSdk="30" id="175319604" name="NOTIFICATION_CANCELLATION_REASONS" /><compat-change description="Rate limit showing toasts, on a per package basis. It limits the number of {@link Toast#show()} calls to prevent overburdening the user with too many toasts in a limited time. Any attempt to show more toasts than allowed in a certain time frame will result in the toast being discarded." id="174840628" loggingOnly="true" name="RATE_LIMIT_TOASTS" /><compat-change description="Whether listeners understand the more specific reason provided for notification cancellations from an assistant, rather than using the more general REASON_LISTENER_CANCEL." enableAfterTargetSdk="32" id="195579280" name="NOTIFICATION_LOG_ASSISTANT_CANCEL" /><compat-change description="NO_CLEAR flag will be set for any media notification." enableAfterTargetSdk="34" id="264179692" name="ENFORCE_NO_CLEAR_FLAG_ON_MEDIA_NOTIFICATION" /><compat-change description="App calls to {@link NotificationManager#setInterruptionFilter} and {@link NotificationManager#setNotificationPolicy} manage DND through the creation and activation of an implicit {@link AutomaticZenRule}." enableSinceTargetSdk="35" id="308670109" name="MANAGE_GLOBAL_ZEN_VIA_IMPLICIT_RULES" /><compat-change description="Send new activation AutomaticZenRule statuses to apps with a min target SDK version" enableSinceTargetSdk="35" id="308673617" name="SEND_ACTIVATION_AZR_STATUSES" /><compat-change description="If an app being installed targets {@link Build.VERSION_CODES#TIRAMISU API 33} and above, the app can be installed without user action. See {@link PackageInstaller.SessionParams#setRequireUserAction} for other conditions required to be satisfied for a silent install." enableSinceTargetSdk="33" id="325888262" name="SILENT_INSTALL_ALLOWED" /><compat-change description="The system supports pre-approval and update ownership features from {@link Build.VERSION_CODES#UPSIDE_DOWN_CAKE API 34}. The change id is used to make sure the system includes the fix of pre-approval with update ownership case. When checking the change id, if it is disabled, it means the build includes the fix. The more detail is on b/293644536. See {@link PackageInstaller.SessionParams#setRequestUpdateOwnership(boolean)} and {@link #requestUserPreapproval(PreapprovalDetails, IntentSender)} for more details." disabled="true" id="293644536" name="PRE_APPROVAL_WITH_UPDATE_OWNERSHIP_FIX" /><compat-change description="Throws IllegalArgumentException if the {@link IntentSender} from an immutable {@link android.app.PendingIntent} when caller has a target SDK of API {@link android.os.Build.VERSION_CODES#VANILLA_ICE_CREAM} or above." enableSinceTargetSdk="35" id="240618202" name="THROW_EXCEPTION_COMMIT_WITH_IMMUTABLE_PENDING_INTENT" /><compat-change description="Adding an installer package name to a package that does not have one set requires the INSTALL_PACKAGES permission. If the caller targets R, this will throw a SecurityException. Otherwise the request will fail silently. In both cases, and regardless of whether this change is enabled, the installer package will remain unchanged." enableAfterTargetSdk="29" id="150857253" name="THROW_EXCEPTION_ON_REQUIRE_INSTALL_PACKAGES_TO_ADD_INSTALLER_PACKAGE" /><compat-change description="Allows opt-in to the latest targetSdkVersion enforced changes without changing target SDK. Turning this change on for an app targeting the latest SDK or higher is a no-op. &lt;p&gt;Has no effect for apps using shared user id. TODO(b/143539591): Update description with relevant SELINUX changes this opts in to." disabled="true" id="143539591" name="SELINUX_LATEST_CHANGES" /><compat-change description="This change gates apps access to untrusted_app_R-targetSDK SELinux domain. Allows opt-in to R targetSdkVersion enforced changes without changing target SDK. Turning this change off for an app targeting {@code &gt;= android.os.Build.VERSION_CODES.R} is a no-op. &lt;p&gt;Has no effect for apps using shared user id. TODO(b/143539591): Update description with relevant SELINUX changes this opts in to." enableAfterTargetSdk="29" id="168782947" name="SELINUX_R_CHANGES" /><compat-change description="Apps targeting Android U and above will need to export components in order to invoke them through implicit intents. &lt;p&gt; If a component is not exported and invoked, it will be removed from the list of receivers. This applies specifically to activities and broadcasts." enableAfterTargetSdk="33" id="229362273" name="IMPLICIT_INTENTS_ONLY_MATCH_EXPORTED_COMPONENTS" overridable="true" /><compat-change description="Intents sent from apps enabling this feature will stop resolving to components with non matching intent filters, even when explicitly setting a component name, unless the target components are in the same app as the calling app. &lt;p&gt; When an app registers an exported component in its manifest and adds &amp;lt;intent-filter&amp;gt;s, the component can be started by any intent - even those that do not match the intent filter. This has proven to be something that many developers find counterintuitive. Without checking the intent when the component is started, in some circumstances this can allow 3P apps to trigger internal-only functionality." disabled="true" id="161252188" name="ENFORCE_INTENTS_TO_MATCH_INTENT_FILTERS" overridable="true" /><compat-change description="Apps targeting Android S and above need to declare dependencies to the public native shared libraries that are defined by the device maker using {@code uses-native-library} tag in its {@code AndroidManifest.xml}. If any of the dependencies cannot be satisfied, i.e. one of the dependency doesn't exist, the package manager rejects to install the app. The dependency can be specified as optional using {@code android:required} attribute in the tag, in which case failing to satisfy the dependency doesn't stop the installation. &lt;p&gt;Once installed, an app is provided with only the native shared libraries that are specified in the app manifest. {@code dlopen}ing a native shared library that doesn't appear in the app manifest will fail even if it actually exists on the device." enableAfterTargetSdk="30" id="142191088" name="ENFORCE_NATIVE_SHARED_LIBRARY_DEPENDENCIES" /><compat-change description="Remove android.test.base library for apps that target SDK R or more and do not depend on android.test.runner (as it depends on classes from the android.test.base library)." enableAfterTargetSdk="29" id="133396946" name="REMOVE_ANDROID_TEST_BASE" /><compat-change description="This change makes it so that apps are told to show rationale for asking for background location access every time they request." enableAfterTargetSdk="29" id="147316723" name="BACKGROUND_RATIONALE_CHANGE_ID" /><compat-change description="With the updated form of the app links verification APIs, an app will be required to declare domains inside an intent filter which includes all of the following: &lt;ul&gt;     &lt;li&gt;- android:autoVerify=&quot;true&quot;&lt;/li&gt;     &lt;li&gt;- Intent.ACTION_VIEW&lt;/li&gt;     &lt;li&gt;- Intent.CATEGORY_BROWSABLE&lt;/li&gt;     &lt;li&gt;- Intent.CATEGORY_DEFAULT&lt;/li&gt;     &lt;li&gt;- Only IntentFilter.SCHEME_HTTP and/or IntentFilter.SCHEME_HTTPS,           with no other schemes&lt;/li&gt; &lt;/ul&gt; &lt;p&gt; On prior versions of Android, Intent.CATEGORY_BROWSABLE was not a requirement, other schemes were allowed, and setting autoVerify to true in any intent filter would implicitly pretend that all intent filters were set to autoVerify=&quot;true&quot;." enableSinceTargetSdk="31" id="175408749" name="RESTRICT_DOMAINS" /><compat-change description="The new user preference API for verifying domains marked autoVerify=true in AndroidManifest.xml intent filters is not yet implemented in the current platform preview. This is anticipated to ship before S releases. For now, it is possible to preview the new user preference changes by enabling this ChangeId and using the &lt;code&gt;adb shell pm set-app-links-user-selection&lt;/code&gt; and similar commands." id="178111421" name="SETTINGS_API_V2" /><compat-change description="This change reflects the presence of the new Notification Permission" enableAfterTargetSdk="32" id="194833441" name="NOTIFICATION_PERM_CHANGE_ID" /><compat-change description="Apps targeting Android V and above need to define {@link android.Manifest.permission#TURN_SCREEN_ON} in their manifest for {@link android.os.PowerManager#ACQUIRE_CAUSES_WAKEUP} to have any effect. Note that most applications should use {@link android.R.attr#turnScreenOn} or {@link android.app.Activity#setTurnScreenOn(boolean)} instead, as this prevents the previous foreground app from being resumed first when the screen turns on." enableSinceTargetSdk="10000" id="216114297" name="REQUIRE_TURN_SCREEN_ON_PERMISSION" /><compat-change description="Apps targeting {@code Build.VERSION_CODES.S} or higher need {@link android.Manifest.permission#STATUS_BAR} permission to collapse the status bar panels due to security reasons. This was being exploited by malware to prevent the user from accessing critical notifications." enableSinceTargetSdk="31" id="173031413" name="LOCK_DOWN_COLLAPSE_STATUS_BAR" /><compat-change description="In apps targeting {@link android.os.Build.VERSION_CODES#TIRAMISU} or higher, calling {@link android.service.quicksettings.TileService#requestListeningState} will check that the calling package (uid) and the package of the target {@link android.content.ComponentName} match. It'll also make sure that the context used can take actions on behalf of the current user." enableAfterTargetSdk="32" id="172251878" name="REQUEST_LISTENING_MUST_MATCH_PACKAGE" /><compat-change description="" enableAfterTargetSdk="33" id="242194868" name="REQUEST_LISTENING_OTHER_USER_NOOP" /><compat-change description="Implementors of the HotwordDetectionService must not augment the phrase IDs which are supplied via HotwordDetectionService #onDetect(AlwaysOnHotwordDetector.EventPayload, long, HotwordDetectionService.Callback). &lt;p&gt;The HotwordDetectedResult#getHotwordPhraseId() must match one of the phrase IDs from the AlwaysOnHotwordDetector.EventPayload#getKeyphraseRecognitionExtras() list. &lt;/p&gt; &lt;p&gt;This behavior change is made to ensure the HotwordDetectionService honors what it receives from the android.hardware.soundtrigger.SoundTriggerModule, and it cannot signal to the client application a phrase which was not originally detected. &lt;/p&gt;" disabled="true" id="215066299" name="ENFORCE_HOTWORD_PHRASE_ID" /><compat-change description="Grants access to the launching app's identity if the app opted-in to sharing its identity by launching this activity with an instance of {@link android.app.ActivityOptions} on which {@link android.app.ActivityOptions#setShareIdentityEnabled(boolean)} was invoked with a value of {@code true}, or if the launched activity's uid is the same as the launching app's. When this change is enabled and one of these requirements is met, the activity can access the launching app's uid and package name with {@link android.app.Activity#getLaunchedFromUid()} and {@link android.app.Activity#getLaunchedFromPackage()}, respectively." id="259743961" name="ACCESS_SHARED_IDENTITY" /><compat-change description="Feature flag for making Activities consume all touches within their task bounds." id="194480991" name="ENABLE_TOUCH_OPAQUE_ACTIVITIES" /><compat-change description="Feature flag to protect PendingIntent being abused to start background activity." enableSinceTargetSdk="33" id="192341120" name="ENABLE_PENDING_INTENT_BAL_OPTION" /><compat-change description="Feature flag for go/activity-security rules" disabled="true" id="230590090" name="ASM_RESTRICTIONS" /><compat-change description="If enabled the creator will not allow BAL on its behalf by default." enableAfterTargetSdk="34" id="296478951" name="DEFAULT_RESCIND_BAL_PRIVILEGES_FROM_PENDING_INTENT_CREATOR" /><compat-change description="If enabled BAL are prevented by default in applications targeting U and later." enableSinceTargetSdk="34" id="261072174" name="DEFAULT_RESCIND_BAL_FG_PRIVILEGES_BOUND_SERVICE" overridable="true" /><compat-change description="To prevent any existing apps from having app compat issue with the non-sdk usages of {@link ClientTransaction#getActivityToken()}, only allow bundling {@link LaunchActivityItem} for apps with targetSDK of V and above." enableSinceTargetSdk="35" id="324203798" name="ENABLE_BUNDLE_LAUNCH_ACTIVITY_ITEM" /><compat-change description="&lt;a href=&quot;#DOWNSCALED_INVERSE&quot;&gt;DOWNSCALED_INVERSE&lt;/a&gt; is the gatekeeper of all per-app buffer inverse downscale changes. Enabling this change will allow the following scaling factors: &lt;a href=&quot;#DOWNSCALE_90&quot;&gt;DOWNSCALE_90&lt;/a&gt; &lt;a href=&quot;#DOWNSCALE_85&quot;&gt;DOWNSCALE_85&lt;/a&gt; &lt;a href=&quot;#DOWNSCALE_80&quot;&gt;DOWNSCALE_80&lt;/a&gt; &lt;a href=&quot;#DOWNSCALE_75&quot;&gt;DOWNSCALE_75&lt;/a&gt; &lt;a href=&quot;#DOWNSCALE_70&quot;&gt;DOWNSCALE_70&lt;/a&gt; &lt;a href=&quot;#DOWNSCALE_65&quot;&gt;DOWNSCALE_65&lt;/a&gt; &lt;a href=&quot;#DOWNSCALE_60&quot;&gt;DOWNSCALE_60&lt;/a&gt; &lt;a href=&quot;#DOWNSCALE_55&quot;&gt;DOWNSCALE_55&lt;/a&gt; &lt;a href=&quot;#DOWNSCALE_50&quot;&gt;DOWNSCALE_50&lt;/a&gt; &lt;a href=&quot;#DOWNSCALE_45&quot;&gt;DOWNSCALE_45&lt;/a&gt; &lt;a href=&quot;#DOWNSCALE_40&quot;&gt;DOWNSCALE_40&lt;/a&gt; &lt;a href=&quot;#DOWNSCALE_35&quot;&gt;DOWNSCALE_35&lt;/a&gt; &lt;a href=&quot;#DOWNSCALE_30&quot;&gt;DOWNSCALE_30&lt;/a&gt; If &lt;a href=&quot;#DOWNSCALED_INVERSE&quot;&gt;DOWNSCALED_INVERSE&lt;/a&gt; is enabled for an app package, then the app will be forcibly resized to the lowest enabled scaling factor e.g. 1/0.8 if both 1/0.8 and 1/0.7 (* 100%) were enabled. When both &lt;a href=&quot;#DOWNSCALED_INVERSE&quot;&gt;DOWNSCALED_INVERSE&lt;/a&gt; and &lt;a href=&quot;#DOWNSCALED&quot;&gt;DOWNSCALED&lt;/a&gt; are enabled, then &lt;a href=&quot;#DOWNSCALED_INVERSE&quot;&gt;DOWNSCALED_INVERSE&lt;/a&gt; takes precedence." disabled="true" id="273564678" name="DOWNSCALED_INVERSE" overridable="true" /><compat-change description="&lt;a href=&quot;#DOWNSCALED&quot;&gt;DOWNSCALED&lt;/a&gt; is the gatekeeper of all per-app buffer downscaling changes. Enabling this change will allow the following scaling factors: &lt;a href=&quot;#DOWNSCALE_90&quot;&gt;DOWNSCALE_90&lt;/a&gt; &lt;a href=&quot;#DOWNSCALE_85&quot;&gt;DOWNSCALE_85&lt;/a&gt; &lt;a href=&quot;#DOWNSCALE_80&quot;&gt;DOWNSCALE_80&lt;/a&gt; &lt;a href=&quot;#DOWNSCALE_75&quot;&gt;DOWNSCALE_75&lt;/a&gt; &lt;a href=&quot;#DOWNSCALE_70&quot;&gt;DOWNSCALE_70&lt;/a&gt; &lt;a href=&quot;#DOWNSCALE_65&quot;&gt;DOWNSCALE_65&lt;/a&gt; &lt;a href=&quot;#DOWNSCALE_60&quot;&gt;DOWNSCALE_60&lt;/a&gt; &lt;a href=&quot;#DOWNSCALE_55&quot;&gt;DOWNSCALE_55&lt;/a&gt; &lt;a href=&quot;#DOWNSCALE_50&quot;&gt;DOWNSCALE_50&lt;/a&gt; &lt;a href=&quot;#DOWNSCALE_45&quot;&gt;DOWNSCALE_45&lt;/a&gt; &lt;a href=&quot;#DOWNSCALE_40&quot;&gt;DOWNSCALE_40&lt;/a&gt; &lt;a href=&quot;#DOWNSCALE_35&quot;&gt;DOWNSCALE_35&lt;/a&gt; &lt;a href=&quot;#DOWNSCALE_30&quot;&gt;DOWNSCALE_30&lt;/a&gt; If &lt;a href=&quot;#DOWNSCALED&quot;&gt;DOWNSCALED&lt;/a&gt; is enabled for an app package, then the app will be forcibly resized to the highest enabled scaling factor e.g. 80% if both 80% and 70% were enabled. When both &lt;a href=&quot;#DOWNSCALED_INVERSE&quot;&gt;DOWNSCALED_INVERSE&lt;/a&gt; and &lt;a href=&quot;#DOWNSCALED&quot;&gt;DOWNSCALED&lt;/a&gt; are enabled, then &lt;a href=&quot;#DOWNSCALED_INVERSE&quot;&gt;DOWNSCALED_INVERSE&lt;/a&gt; takes precedence." disabled="true" id="168419799" name="DOWNSCALED" overridable="true" /><compat-change description="With &lt;a href=&quot;#DOWNSCALED&quot;&gt;DOWNSCALED&lt;/a&gt; enabled, subsequently enabling change-id &lt;a href=&quot;#DOWNSCALE_90&quot;&gt;DOWNSCALE_90&lt;/a&gt; for a package will force the app to assume it's running on a display with 90% the vertical and horizontal resolution of the real display. With &lt;a href=&quot;#DOWNSCALED_INVERSE&quot;&gt;DOWNSCALED_INVERSE&lt;/a&gt; enabled will force the app to assume it's running on a display with 111.11% the vertical and horizontal resolution of the real display" disabled="true" id="182811243" name="DOWNSCALE_90" overridable="true" /><compat-change description="With &lt;a href=&quot;#DOWNSCALED&quot;&gt;DOWNSCALED&lt;/a&gt; enabled, subsequently enabling change-id &lt;a href=&quot;#DOWNSCALE_85&quot;&gt;DOWNSCALE_85&lt;/a&gt; for a package will force the app to assume it's running on a display with 85% the vertical and horizontal resolution of the real display. With &lt;a href=&quot;#DOWNSCALED_INVERSE&quot;&gt;DOWNSCALED_INVERSE&lt;/a&gt; enabled will force the app to assume it's running on a display with 117.65% the vertical and horizontal resolution of the real display" disabled="true" id="189969734" name="DOWNSCALE_85" overridable="true" /><compat-change description="With &lt;a href=&quot;#DOWNSCALED&quot;&gt;DOWNSCALED&lt;/a&gt; enabled, subsequently enabling change-id &lt;a href=&quot;#DOWNSCALE_80&quot;&gt;DOWNSCALE_80&lt;/a&gt; for a package will force the app to assume it's running on a display with 80% the vertical and horizontal resolution of the real display. With &lt;a href=&quot;#DOWNSCALED_INVERSE&quot;&gt;DOWNSCALED_INVERSE&lt;/a&gt; enabled will force the app to assume it's running on a display with 125% the vertical and horizontal resolution of the real display" disabled="true" id="176926753" name="DOWNSCALE_80" overridable="true" /><compat-change description="With &lt;a href=&quot;#DOWNSCALED&quot;&gt;DOWNSCALED&lt;/a&gt; enabled, subsequently enabling change-id &lt;a href=&quot;#DOWNSCALE_75&quot;&gt;DOWNSCALE_75&lt;/a&gt; for a package will force the app to assume it's running on a display with 75% the vertical and horizontal resolution of the real display. With &lt;a href=&quot;#DOWNSCALED_INVERSE&quot;&gt;DOWNSCALED_INVERSE&lt;/a&gt; enabled will force the app to assume it's running on a display with 133.33% the vertical and horizontal resolution of the real display" disabled="true" id="189969779" name="DOWNSCALE_75" overridable="true" /><compat-change description="With &lt;a href=&quot;#DOWNSCALED&quot;&gt;DOWNSCALED&lt;/a&gt; enabled, subsequently enabling change-id &lt;a href=&quot;#DOWNSCALE_70&quot;&gt;DOWNSCALE_70&lt;/a&gt; for a package will force the app to assume it's running on a display with 70% the vertical and horizontal resolution of the real display. With &lt;a href=&quot;#DOWNSCALED_INVERSE&quot;&gt;DOWNSCALED_INVERSE&lt;/a&gt; enabled will force the app to assume it's running on a display with 142.86% the vertical and horizontal resolution of the real display" disabled="true" id="176926829" name="DOWNSCALE_70" overridable="true" /><compat-change description="With &lt;a href=&quot;#DOWNSCALED&quot;&gt;DOWNSCALED&lt;/a&gt; enabled, subsequently enabling change-id &lt;a href=&quot;#DOWNSCALE_65&quot;&gt;DOWNSCALE_65&lt;/a&gt; for a package will force the app to assume it's running on a display with 65% the vertical and horizontal resolution of the real display. With &lt;a href=&quot;#DOWNSCALED_INVERSE&quot;&gt;DOWNSCALED_INVERSE&lt;/a&gt; enabled will force the app to assume it's running on a display with 153.85% the vertical and horizontal resolution of the real display" disabled="true" id="189969744" name="DOWNSCALE_65" overridable="true" /><compat-change description="With &lt;a href=&quot;#DOWNSCALED&quot;&gt;DOWNSCALED&lt;/a&gt; enabled, subsequently enabling change-id &lt;a href=&quot;#DOWNSCALE_60&quot;&gt;DOWNSCALE_60&lt;/a&gt; for a package will force the app to assume it's running on a display with 60% the vertical and horizontal resolution of the real display. With &lt;a href=&quot;#DOWNSCALED_INVERSE&quot;&gt;DOWNSCALED_INVERSE&lt;/a&gt; enabled will force the app to assume it's running on a display with 166.67% the vertical and horizontal resolution of the real display" disabled="true" id="176926771" name="DOWNSCALE_60" overridable="true" /><compat-change description="With &lt;a href=&quot;#DOWNSCALED&quot;&gt;DOWNSCALED&lt;/a&gt; enabled, subsequently enabling change-id &lt;a href=&quot;#DOWNSCALE_55&quot;&gt;DOWNSCALE_55&lt;/a&gt; for a package will force the app to assume it's running on a display with 55% the vertical and horizontal resolution of the real display. With &lt;a href=&quot;#DOWNSCALED_INVERSE&quot;&gt;DOWNSCALED_INVERSE&lt;/a&gt; enabled will force the app to assume it's running on a display with 181.82% the vertical and horizontal resolution of the real display" disabled="true" id="189970036" name="DOWNSCALE_55" overridable="true" /><compat-change description="With &lt;a href=&quot;#DOWNSCALED&quot;&gt;DOWNSCALED&lt;/a&gt; enabled, subsequently enabling change-id &lt;a href=&quot;#DOWNSCALE_50&quot;&gt;DOWNSCALE_50&lt;/a&gt; for a package will force the app to assume it's running on a display with 50% vertical and horizontal resolution of the real display. With &lt;a href=&quot;#DOWNSCALED_INVERSE&quot;&gt;DOWNSCALED_INVERSE&lt;/a&gt; enabled will force the app to assume it's running on a display with 200% the vertical and horizontal resolution of the real display" disabled="true" id="176926741" name="DOWNSCALE_50" overridable="true" /><compat-change description="With &lt;a href=&quot;#DOWNSCALED&quot;&gt;DOWNSCALED&lt;/a&gt; enabled, subsequently enabling change-id &lt;a href=&quot;#DOWNSCALE_45&quot;&gt;DOWNSCALE_45&lt;/a&gt; for a package will force the app to assume it's running on a display with 45% the vertical and horizontal resolution of the real display. With &lt;a href=&quot;#DOWNSCALED_INVERSE&quot;&gt;DOWNSCALED_INVERSE&lt;/a&gt; enabled will force the app to assume it's running on a display with 222.22% the vertical and horizontal resolution of the real display" disabled="true" id="189969782" name="DOWNSCALE_45" overridable="true" /><compat-change description="With &lt;a href=&quot;#DOWNSCALED&quot;&gt;DOWNSCALED&lt;/a&gt; enabled, subsequently enabling change-id &lt;a href=&quot;#DOWNSCALE_40&quot;&gt;DOWNSCALE_40&lt;/a&gt; for a package will force the app to assume it's running on a display with 40% the vertical and horizontal resolution of the real display. With &lt;a href=&quot;#DOWNSCALED_INVERSE&quot;&gt;DOWNSCALED_INVERSE&lt;/a&gt; enabled will force the app to assume it's running on a display with 250% the vertical and horizontal resolution of the real display" disabled="true" id="189970038" name="DOWNSCALE_40" overridable="true" /><compat-change description="With &lt;a href=&quot;#DOWNSCALED&quot;&gt;DOWNSCALED&lt;/a&gt; enabled, subsequently enabling change-id &lt;a href=&quot;#DOWNSCALE_35&quot;&gt;DOWNSCALE_35&lt;/a&gt; for a package will force the app to assume it's running on a display with 35% the vertical and horizontal resolution of the real display. With &lt;a href=&quot;#DOWNSCALED_INVERSE&quot;&gt;DOWNSCALED_INVERSE&lt;/a&gt; enabled will force the app to assume it's running on a display with 285.71% the vertical and horizontal resolution of the real display" disabled="true" id="189969749" name="DOWNSCALE_35" overridable="true" /><compat-change description="With &lt;a href=&quot;#DOWNSCALED&quot;&gt;DOWNSCALED&lt;/a&gt; enabled, subsequently enabling change-id &lt;a href=&quot;#DOWNSCALE_30&quot;&gt;DOWNSCALE_30&lt;/a&gt; for a package will force the app to assume it's running on a display with 30% the vertical and horizontal resolution of the real display. With &lt;a href=&quot;#DOWNSCALED_INVERSE&quot;&gt;DOWNSCALED_INVERSE&lt;/a&gt; enabled will force the app to assume it's running on a display with 333.33% the vertical and horizontal resolution of the real display" disabled="true" id="189970040" name="DOWNSCALE_30" overridable="true" /><compat-change description="On Android TV applications that target pre-S are not expecting to receive a Window larger than 1080p, so if needed we are downscaling their Windows to 1080p. However, applications that target S and greater release version are expected to be able to handle any Window size, so we should not downscale their Windows." enableSinceTargetSdk="31" id="157629738" name="DO_NOT_DOWNSCALE_TO_1080P_ON_TV" overridable="true" /><compat-change description="Application is allowed to receive the {@link android.window.SplashScreen.OnExitAnimationListener#onSplashScreenExit(SplashScreenView)} callback, even when the splash screen only shows a solid color." enableSinceTargetSdk="33" id="205907456" name="ALLOW_COPY_SOLID_COLOR_VIEW" /></config>